const clc = require('cli-color');

const space = ' ';

function isNumeric(str) {
  if (typeof str != 'string') {
    return false;
  }

  return !isNaN(str) && !isNaN(parseFloat(str));
}

function printObject(obj, indention = 0, parentKey = null) {
  if (Array.isArray(obj) || typeof obj === 'object') {
    if (Array.isArray(obj)) {
      console.log(
        `${space.repeat(indention)}${
          typeof parentKey === 'string' ? clc.cyanBright(parentKey + ': ') : ''
        }[`
      );
      for (let key in obj) {
        printObject(obj[key], indention + 2, typeof key === 'string' ? key : null);
      }
      console.log(`${space.repeat(indention)}],`);
    } else {
      console.log(
        `${space.repeat(indention)}${typeof key === 'undefined' ? '' : clc.cyanBright(key + ': ')}{`
      );
      for (let key in obj) {
        printObject(obj[key], indention + 2, key);
      }
      console.log(`${space.repeat(indention)}},`);
    }
  } else {
    const output = clc.xterm(137);
    console.log(
      `${space.repeat(indention)}${isNumeric(parentKey) ? '' : clc.cyanBright(parentKey + ': ')}${
        typeof obj === 'string'
          ? output('"' + obj + '"') + clc.white(',')
          : clc.yellow(obj) + clc.white(',')
      }`
    );
  }
}

const json = {
  log(obj) {
    if (Array.isArray(obj) || typeof obj === 'object') {
      printObject(obj);
    } else {
      throw new Error('Give me the Jason object!');
    }
  },
};

exports.json = json;
